/*  HEADER FILE: stream.h 
 *  DESCRIPTION: This file defines the structure and type needed
 *  		 to represent CHARACTER_STREAM in stream module.  
 *		 All functions used by character stream module are
 * 		 also defined below.
 */

#define FALSE 0
#define TRUE  1
#define MAX_STREAM_LENGTH 256  /* maximum length of the stream read */ 

/*  The following declaration make up the user-defined type of 
 *  CHARACTER_STREAM.
 *  A character stream consists of a string of characters.  An
 *  index is used to keep the current position in the stream.
 */

struct character_stream_record  
   {
	char string[MAX_STREAM_LENGTH];
	int  pos; 
   }; 

typedef struct character_stream_record CHARACTER_STREAM; 

CHARACTER_STREAM open_character_stream();
char get_char();
int is_end_of_character_stream();
void push_char();
void unget_error();

