/* stream.c */

/*     -- character_stream_module --
 *
 *  FUNCTIONS :
 *
 *    open_character_stream ( FILENAME: string ) : character_stream;
 *    get_char ( VAR S: character_stream) : CHARACTER;
 *    is_end_of_character_stream ( S: character_stream); : BOOLEAN;
 *    unget_char ( C: CHARACTER; VAR S: character_stream);
 *
 *  EXCEPTION  : unget_error ( S: character_stream);
 *  REASIED BY : unget_char();
 */

#include <stdio.h>
#include "stream.h" 

extern unget_error();


/*  NAME     : open_character_stream()
 *  FUNCTION : it associates the sequence of characters in file : FILENAME
 *             to the character_stream
 *  PARA     : FILENAME -- On entry, the file name, or NULL for stdin
 *  RETURN   : the character_stream
 */

character_stream open_character_stream(FILENAME)
  string FILENAME;
{
  character_stream stream;
   
  if (FILENAME==NULL) stream=stdin;
  else if ((stream=fopen(FILENAME,"r+"))==NULL) {
    fprintf(stderr,"can not open charactor_stream : %s \n",FILENAME);
    exit(1);
  }
  return(stream);
}




/*  NAME     : get_char()
 *  FUNCTION : it gets the first character of the character_stream : S
 *             and associates S to the remaining 
 *  PARA     : S -- On entry, the character_stream
 *                  On exit,  the remaining character_stream
 *  RETURN   : the first character
 */

CHARACTER get_char(S)
  character_stream S;
{ 
  return(fgetc(S));
}




/*  NAME     : is_end_of_character_stream()
 *  FUNCTION : it checks if the character_stream : S is empty
 *  PARA     : S -- On entry/exit, the character_stream
 *  RETURN   : the BOOLEAN value
 */

BOOLEAN is_end_of_character_stream(S)
  character_stream S;
{
  CHARACTER C;

  if (feof(S)) return(SUCCED);
  else return(FAIL);
}




/*  NAME     : unget_char()
 *  FUNCTION : it puts the CHARACTER : C back to the head of the character_stream : S
 *             and associates S to the new character_stream
 *  PARA     : C -- On entry, the CHARACTER
 *             S -- On entry, the character_stream
 *                  On exit,  the new character_stream
 *  RETURN   : not sepecify
 *  NOTE     : if can not put C back to S, it calls extern function unget_error()
 *             which is specified by the user of this module
 */

void unget_char(C,S)
  CHARACTER C;
  character_stream S;
{
  if (ungetc(C,S)==EOF) unget_error(S);
}
 
              
 
