/*************************************************************
    THIS MODULE ACCEPTS A STREAM OF CHARACTERS FROM A FILE OR
    STANDARD INPUT  AND RETURNS A POINTER TO THE STREAM .
    FUNCTION "open_character_stream(arg)" TAKES CARE OF THIS.
    FUNCTION      */



/************************************************************
* File name    : stream.c
* Purpose      : To open a character stream , return a char. 
*               to unget a character and to check whether it 
*               is end of character stream or not.
* Needs        : Header files stream.h and tokens.h
***********************************************************/



#include <stdio.h>
#define SUCCESS 1;

/***********************************************************
* Module name   :(character_stream)open_character_stream(arg)
*                   arg : character_stream;
* inputs        : a filename a string
* outputs       : a character stream
* Functions     : (FILE *)fopen(arg1:char *;arg2 : char *) 
* Description   : returns a character stream
************************************************************/

FILE *open_character_stream(file)
  char *file;
  {
  FILE *file_ptr;
  if(file  == NULL)file_ptr = stdin;
  else if((file_ptr = fopen(file,"r")) == NULL){
              printf("No permission\n");
              printf("BYE\n");
              exit(1);
             }
  return(file_ptr);
}




/***********************************************************
* Module name   :(character)get_char(stream:character_stream)
* inputs        : a character_stream 
* outputs       : a character 
* Functions     : (FILE *)fgetc(arg1 : character_stream) 
* Descriptions  : returns a character
************************************************************/



char get_char(stream)
 FILE *stream;
{
  char ch;
   ch = fgetc(stream);
  return(ch);
}



/***********************************************************
* Module name   :(void)unget_error()                         
* inputs        : Nill               
* outputs       : Nill        
* Functions     : Nill                                   
* Description   : puts a character to a file
************************************************************/


void unget_error(){
 printf("No space in file\n");
 printf("exiting \n");
 exit(1);
}


/***********************************************************
* Module name   :(boolean)unget_char(arg1,arg2)
*                  arg1:character
*                  arg2:character_stream
* inputs        : character and a character_stream
* outputs       : boolean     
* Functions     : ungetc(ch,stream)
*                 ch:character;
*                 stream : character_stream;
* Description   : This fn. puts back a char into the buffer 
*                  for a file while using getchar()
* Exceptions    : Fn. unget_char() should'nt be called consec-
*                 utively before calling getchar()
************************************************************/
int unget_char(letter,stream)
char  letter;
FILE *stream;
{
  if(ungetc(letter,stream) == EOF)unget_error();
  else return 1;
}




/***********************************************************
* Module name   :(boolean)unget_char(arg1,arg2)
*                  arg1:character
*                  arg2:character_stream
* inputs        : character and a character_stream
* outputs       : boolean     
* Functions     : ungetc(ch,stream)
*                 ch:character;
*                 stream : character_stream;
* Description   : This fn. puts back a char into the buffer 
*                  for a file while using getchar()
* Exceptions    : Fn. unget_char() should'nt be called consec-
*                 utively before calling getchar()
************************************************************/
int is_end_of_character_stream(stream)
 FILE *stream;

  {
    char ch;
   if((ch = fgetc(stream))==EOF)
         return 1;
  else {
        unget_char(ch,stream);
        return 0;
       }
  }
