/***************************************************************************/
/*                              "main.c"                                   */
/*    This is the main program which has the function 'main()', which      */
/*    checks the no. of arguments. If only one argument is  specified      */
/*    it indicates, no file name is give, then the file pointer  will      */
/*    be the stdin, else it takes the second argument as the name  of      */
/*    file and opens the file and assings the file pointer to it.Then      */
/*    it calls two functions, the first, which initializes  the  file      */
/*    pointer variable in data_structure defined in calculator.h, and      */
/*    also initializes the second variable of the data_str, i.e., the      */
/*    symbol table. Then it calls the second function evaluate_a_line      */
/*    which evaluates the line and returns FALSE if a command  'quit'      */
/*    or a EOF is reached, else returns TRUE.                              */
/***************************************************************************/
#include <stdio.h>
#include "boolean.h"
#include "calculator.h"


main(int argc, char **argv)
{
   FILE *fp;
   calc *CALC;
   boolean status;
   
   if(argc>2){
         printf("Too many arguments\n");
         exit(1);
   }
   if(argc == 1)
         fp = stdin;

   else if((fp = fopen(*(argv+1),"r")) ==NULL){

         printf("Error: cannot open file\n");
         exit(1);
   }
   CALC = initialize_calculator(fp);
    
   status = TRUE; 
   system("clear");
   while(status==TRUE){
        printf("calc> ");
        status= evaluate_a_line(CALC); 
        if(status==FALSE) {
            if(argc==2)
                 printf("\n");
            exit(0);
        }
   }
   fclose(fp);
   exit(0);
}
/***************************************************************************/
